#ifndef MPC_CONTROLLER_STRUCT_H
#define MPC_CONTROLLER_STRUCT_H

#include <MPC/mpc-gen.hpp>

/***********************************************************************/
/* MPC_controller running mode */

#define CTRLER_NOT_RUNNING 0
#define CTRLER_SIMPLE_CONTROLLER 1 
#define CTRLER_TRAJECTORY_FOLLOWING 2 
/* #define CTRLER_TRAJECTORY_SELECTION 3                                      /\* !!! must be removed !!! *\/ */
#define CTRLER_CTRAJ_TRACKING 4

#define MPC_CONTROLLER_MODE int


/***********************************************************************/
/**************************** Requests I/O *****************************/
/***********************************************************************/

/***********************************************************************/
/* Initialization parameters */

typedef struct INIT_I
{
/*   char robot[256]; */
  char pomPoster[256];
  char demPoster[256];
  char strajPoster[256];
} INIT_I;


/***********************************************************************/
/* GoTo / TrajSelTo parameters */

typedef struct GOTO_I
{
/*   POS_XY goal; */
  GENPOS_CART_CONFIG goal;
} GOTO_I;


/***********************************************************************/
/* SetManaSys parameters */

typedef struct SETMANASYS_I
{
  double body_length;
  double body_width;
  double body_z;
  double ground_clearance;
  double rollMax;
  double pitchMax;
  double vmin;
  double vmax;
  double accel;
  double decel;
  double wmax;
} SETMANASYS_I;


/***********************************************************************/
/* TrackCTraj parameters */

typedef struct TRACKCTRAJ_I
{
  char ctrajPoster[256];
  float ctraj_eval_time;
} TRACKCTRAJ_I;


#endif /* MPC_CONTROLLER_STRUCT_H */
